module Cases where

data Foo = Foo Int | Bar

f :: Foo-> Int
f foo = case foo of Foo i -> i; Bar -> 0

g :: Foo-> Int
g foo = case foo of Foo i -> 9; Bar -> 0

{- Try this:
f Bar
f (Foo undefined)
g Bar
g (Foo undefined)

*Cases> f Bar
0
*Cases> f (Foo undefined)
*** Exception: Prelude.undefined
*Cases> g Bar
0
*Cases> g (Foo undefined)
9

-}

-- This shows how undefined values are passed along:
add :: Foo-> Foo-> Foo
add (Foo i) (Foo j) = Foo (i+ j)
add _ _ = Bar

{- Try this: in the second case, the undefined value gets passed along add
   and is then thrown away:
f (add (Foo undefined) (Foo 1))
g (add (Foo undefined) (Foo 1))
f (add (Foo undefined) Bar)

*Cases> f (add (Foo undefined) (Foo 1))
*** Exception: Prelude.undefined
*Cases> g (add (Foo undefined) (Foo 1))
9
*Cases> f (add (Foo undefined) Bar)
0
*Cases> 

-}
